import React from 'react';
import { InlineSVGError } from './utils';
export interface IProps {
    baseURL?: string;
    cacheRequests?: boolean;
    children?: React.ReactNode;
    description?: string;
    loader?: React.ReactNode;
    onError?: (error: InlineSVGError | IFetchError) => void;
    onLoad?: (src: URL | string, isCached: boolean) => void;
    preProcessor?: (code: string) => string;
    src: string;
    title?: string;
    uniqueHash?: string;
    uniquifyIDs?: boolean;
    [key: string]: any;
}
export interface IState {
    content: string;
    element: React.ReactNode;
    hasCache: boolean;
    status: string;
}
export interface IFetchError extends Error {
    message: string;
    type: string;
    errno: string;
    code: string;
}
export interface IStorageItem {
    url: string;
    content: string;
}
export declare const STATUS: {
    FAILED: string;
    LOADED: string;
    LOADING: string;
    PENDING: string;
    READY: string;
    UNSUPPORTED: string;
};
export declare const storage: IStorageItem[];
export default class InlineSVG extends React.PureComponent<IProps, IState> {
    static defaultProps: {
        cacheRequests: boolean;
        uniquifyIDs: boolean;
    };
    private _isMounted;
    constructor(props: IProps);
    componentDidMount(): void;
    componentDidUpdate(prevProps: IProps, prevState: IState): void;
    componentWillUnmount(): void;
    private parseSVG;
    private updateSVGAttributes;
    private generateNode;
    private generateElement;
    private load;
    private handleLoad;
    private handleError;
    private request;
    render(): {} | null;
}
